package bleutils;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Timer;
import java.util.TimerTask;

import com.clj.fastble.data.BleDevice;
import com.example.passivebledemo.MainActivity;
import com.example.passivebledemo.R;
import com.example.z_android_sdk.Reader;

import android.bluetooth.BluetoothAdapter;
import android.content.Context;
import android.content.DialogInterface;
import android.graphics.Color;
import android.util.Log;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ListView;
import demoui.ble.BleAdapter;
import demoui.ble.BleDevices;
import demoui.ble.ListViewDialog;
import demoui.ble.LoadingDialog;
import tools.DemoConfig;

public class BleHandle {
	
	public static String TAG = "BlueTooth";
	
	public static Context context;
	public static MainActivity mainActivity;
	
    ////////////////////   RFID   ////////////////////////
	
	public static Reader ReaderController;
	
    ////////////////////   ر   ////////////////////////
	
	/**
	 * 
	 */
	BluetoothAdapter mBluetoothAdapter;	
	
	/**
	 * ״̬
	 */
	public static boolean bleConnectState = false;
	
	/**
	 * ǰӿ
	 */
	public static BleDevice actionBleDevice;
	
	/**
	 * ǷΪ״ӣ״ϴӹ
	 */
	public static Boolean isFirstConnect = true;
	
	/////////////////////////  бDialog   /////////////////////////
	
	//ListView󣬽xmlļеListViewؼͨidķʽ󶨰
	private static ListView bleListView;
	//һList飬
	private static List<BleDevices> bleDevicesList = new ArrayList<BleDevices>();
	//һʵ
	private static BleAdapter bleAdapter;
	
	/**
	 * ȡ¼
	 */
	private static int GetBleDevicesIndex = 0;
	
	
	public BleHandle(Context context,Reader ReaderController)
	{
		this.context = context;
		mainActivity = (MainActivity)context;
		this.ReaderController = ReaderController;
		
//		ReaderController._bles.setFilterBleName(new String[]{ "0200","0220" });//ɨ豸
	}
	
	
	/**
	 * ʼ
	 */
	public boolean InitBlueToothAdapter()
	{
		mBluetoothAdapter = BluetoothAdapter.getDefaultAdapter();
		if (mBluetoothAdapter == null) return false;	
		return true;
	}
	
	
	/**
	 * ȡ״̬
	 * @return
	 */
	public boolean BlueToothState()
	{
		return mBluetoothAdapter.isEnabled();
	}
	
	
	/**
	 * 
	 */
	public void OpenBlueTooth()
	{
		if(!BlueToothState()) 
		{
			boolean ret = mBluetoothAdapter.enable();
//			Log.e(TAG, "⵽δִϣ=" + ret);
		}
	}
	
	
	/**
	 * ر
	 */
	public void CloseBlueTooth()
	{
		if(BlueToothState()) 
		{
			boolean ret = mBluetoothAdapter.disable();
//			Log.e(TAG, "رִϣ=" + ret);
		}
	}
	
	
	/**
	 * ɨ豸
	 */
	public void StartScanBlueToothDevice()
	{
		ReaderController._bles.ScanTime = 6000;//ɨʱ䣻λΪms 
		ReaderController._bles.scanBle();//ִɨ
		
		Log.e(TAG, "ѿʼɨ");
	}
	
	
	/**
	 * ֹͣɨ豸
	 */
	public void StopScanBlueToothDevice()
	{
		ReaderController._bles.StopscanBle();
		
		Log.e(TAG, "ֹͣɨ");
	}
	
	
	/**
	 * 豸
	 * @param bleDevice
	 */
	public void ConnectBleDevice(BleDevice bleDevice)
	{
		ReaderController._bles.ConnectDev(bleDevice);		
		Log.e(TAG, "ִӣ=" + bleDevice.getName());
	}
	
	
	/**
	 * Ͽ豸
	 * @param bleDevice
	 */
	public void DisConnectBleDevice(BleDevice bleDevice)
	{
		ReaderController._bles.disconnect();	
		Log.e(TAG, "ѶϿӣ=" + bleDevice.getName());
	}
	
	
	public static ListViewDialog bleListDialog;
	/**
	 * listviewʼɨ
	 */
	public void ResetListViewDialogAndScanBle()
	{
		GetBleDevicesIndex = 0;
		bleDevicesList = new ArrayList<BleDevices>();
		bleAdapter = new BleAdapter(context, bleDevicesList);// ʵ󣬲ҽclassͶΪ
		bleAdapter.notifyDataSetChanged();

		// ʼؼ ò ¼
		bleListDialog = new ListViewDialog(context,new ListViewDialog.ListViewDialogButtonListener() {
			@Override
			public void onClick(View view) {
				switch(view.getId())
				{
				case R.id.CancelBtn:
					ListDiaLogButtonClickMethod();
					break;				
				}			
			}
		});
		bleListDialog.setCancelable(true);//öԻǷԳ
		bleListDialog.getmListView().setAdapter(bleAdapter);
		//Ĭϵⲿؼʧ
		bleListDialog.setOnCancelListener(new DialogInterface.OnCancelListener() {
			@Override
			public void onCancel(DialogInterface dialog) {
				// ҪĲ
				if(bleListDialog != null) bleListDialog.cancel();
				bleListDialog = null;
				Log.e(TAG, "ؼհ״dialogʧ");
				StopScanBlueToothDevice();//ֹͣɨ	
				UpdateBleDeviceTimerStop();//ֹͣ¶ʱ
			}
		});
		bleListDialog.getmListView().setOnItemClickListener(new AdapterView.OnItemClickListener() {
			@Override
			public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
				if(bleListDialog != null) bleListDialog.cancel();
				bleListDialog = null;
//            	Toast.makeText(MainActivity.this, "" + position, Toast.LENGTH_SHORT).show();
				ListViewDialogItemClick(position);
			}

		});
		
		bleListDialog.show();		
		Log.e(TAG, "Ѽɨ豸бɨ豸бʱ");
		UpdateBleDeviceTimerStart();
	}
	
	
	/**
	 * ɨбĳһ
	 * @param position
	 */
	public void ListViewDialogItemClick(int position)
	{
		StopScanBlueToothDevice();//ֹͣɨ
		UpdateBleDeviceTimerStop();//ֹͣ¶ʱ
		
		actionBleDevice = bleDevicesList.get(position).getBleDevice();
		Log.e(TAG, "=" + actionBleDevice.getName() + ",Mac=" + actionBleDevice.getMac());	
		ConnectBleDevice(actionBleDevice);//豸
		
		mainActivity.mLoadingDialog.setConnectingText("[" + actionBleDevice.getName() + "]" + 
				"\r\n" + MainActivity.GetResourceString(R.string.Connecting));
		mainActivity.mLoadingDialog.show();
	}
	
	
    /**
     * 豸бťִк
     */
	public void ListDiaLogButtonClickMethod()
	{
		try
		{
			String buttonStr = bleListDialog.getButtonText();
			if(buttonStr.equals(MainActivity.GetResourceString(R.string.Cancel)))
			{
				//رյ
				if(bleListDialog != null) bleListDialog.cancel();
				bleListDialog = null;		
				StopScanBlueToothDevice();//ֹͣɨ
				UpdateBleDeviceTimerStop();//ֹͣ¶ʱ
			}
			else//ɨ
			{
				bleListDialog.setPromptText(MainActivity.GetResourceString(R.string.BleSearching));
				bleListDialog.setProgressBarVisibility(View.VISIBLE);
				bleListDialog.setButtonText(MainActivity.GetResourceString(R.string.Cancel));
				
				GetBleDevicesIndex = 0;
				bleDevicesList = new ArrayList<BleDevices>();
				bleAdapter = new BleAdapter(context, bleDevicesList);// ʵ󣬲ҽclassͶΪ
				bleAdapter.notifyDataSetChanged();
				
				bleListDialog.getmListView().setAdapter(bleAdapter);
				
				Thread.sleep(200);
				
				UpdateBleDeviceTimerStart();//¶ʱ
				StartScanBlueToothDevice();//ʼɨ
			}
		}
		catch(Exception ex)
		{
			
		}
	}
	
	
    /////////////////////////  ȡɨ赽豸ʱ   /////////////////////////
	
    /**
     * ʱ
     */
    public void UpdateBleDeviceTimerStart()
    {
        if(updateBleDeviceTimer == null)
        {
        	updateBleDeviceTimer = new Timer();
        	UpdateBleDeviceTimerRun();
        }
    }

    /**
     * ֹͣʱ
     */
    public void UpdateBleDeviceTimerStop()
    {
        if(updateBleDeviceTimer != null)
        {
        	updateBleDeviceTimer.cancel();
        	updateBleDeviceTimer = null;
        }
    }

    /**
     * ʱ
     */
    Timer updateBleDeviceTimer = null;
    public void UpdateBleDeviceTimerRun() {
    	updateBleDeviceTimer.schedule(new TimerTask() {
            @Override
            public void run() {
            	UpdateBleDeviceTimerMethod();
            }
        }, 0, 500);
    }
	
	
    /**
     * 豸б
     */
    public void UpdateBleDeviceTimerMethod()
    {
    	mainActivity.runOnUiThread(new Runnable() {
			@Override
			public void run() {
				
				List<BleDevice> bleDeviceList;
				if (ReaderController._bles.isScanFinsh == false) //ɨδ
				{
					bleDeviceList = ReaderController._bles.GetBleList();
					if(bleDeviceList.size() != 0)
					{
						int StartIndex = GetBleDevicesIndex;
						for (int i = StartIndex; i < bleDeviceList.size(); i++) 
						{
							UpdateBleDevicesList(bleDeviceList.get(i));
							GetBleDevicesIndex++;
						}
					}								
				}
				else// ɨѽ
				{
					//ȡťΪɨ
					if(bleListDialog != null) 
					{					
						bleListDialog.setPromptText(MainActivity.GetResourceString(R.string.BleSearchFinish));
						bleListDialog.setProgressBarVisibility(View.GONE);
						bleListDialog.setButtonText(MainActivity.GetResourceString(R.string.ReScan));
					}
					UpdateBleDeviceTimerStop();//ֹͣ¶ʱ
				}

			}
		});
    }
	
	
    /**
     * 豸󼯺
     */
    public void UpdateBleDevicesList(BleDevice bleDevice)
    {
    	BleDevices bleDevices;
    	
    	//MacжǷΪ֮ǰ豸 	
    	Boolean isLastConnectBleDevice = CheckLastConnectBleDeviceMac(bleDevice.getMac());
    	String RecordStr = "";
    	if(isLastConnectBleDevice) RecordStr = MainActivity.GetResourceString(R.string.LastConnect);
    	
    	if(bleDevice.getName() == null || bleDevice.getName().equals(""))
    	{
    		bleDevices = new BleDevices(MainActivity.GetResourceString(R.string.UnKnowName),bleDevice.getMac(),RecordStr,bleDevice.getRssi(), 
    				R.drawable.ic_unknownble,Color.parseColor("#a10015"),bleDevice);
    	}
    	else
    	{
    		Boolean isRfidDevice = false;
    		if(bleDevice.getName().length() > 4)
    		{
    			if(bleDevice.getName().substring(0, 4).equals("0200") || bleDevice.getName().substring(0, 4).equals("0220")) isRfidDevice = true;   			
    		}
    		
    		if(isRfidDevice)
    		{
    			bleDevices = new BleDevices(bleDevice.getName(),bleDevice.getMac(),RecordStr,bleDevice.getRssi(), 
    					R.drawable.ic_rfidble,Color.parseColor("#0b988f"),bleDevice);
    		}
    		else
    		{
    			bleDevices = new BleDevices(bleDevice.getName(),bleDevice.getMac(),RecordStr,bleDevice.getRssi(), 
    					R.drawable.ic_knowble,Color.parseColor("#000000"),bleDevice);
    		}
    	}   	
    	
    	bleDevicesList.add(bleDevices);
//    	UpdateBleDevicesListRssi();
    	Collections.sort(bleDevicesList); // RSSI
		bleAdapter.notifyDataSetChanged();
		
		if(isLastConnectBleDevice) FirstConnectForLastBleDevice(bleDevice);
    }
    
    /**
     * ǷΪϴ豸ǣ򷵻true
     */
    public Boolean CheckLastConnectBleDeviceMac(String mac)
    {
    	Boolean ret = false;   	
    	if(DemoConfig.LastConnectBleMac.equals(mac)) ret = true;
    	return ret;
    }
    
    
    /**
     * ״ֱϴӹ
     */
    public void FirstConnectForLastBleDevice(BleDevice bleDevice)
    {
    	if(isFirstConnect)
    	{
    		isFirstConnect = false;
    		
			if(bleListDialog != null) bleListDialog.cancel();
			bleListDialog = null;
			
			StopScanBlueToothDevice();//ֹͣɨ
			UpdateBleDeviceTimerStop();//ֹͣ¶ʱ
			
			actionBleDevice = bleDevice;
			Log.e(TAG, "=" + actionBleDevice.getName() + ",Mac=" + actionBleDevice.getMac());	
			ConnectBleDevice(actionBleDevice);//豸
			
			mainActivity.mLoadingDialog.setConnectingText("[" + actionBleDevice.getName() + "]" + 
			"\r\n" + MainActivity.GetResourceString(R.string.Connecting));
			mainActivity.mLoadingDialog.show();
    	} 	
    }
    
    
    /**
     * 豸бRSSIֵ
     */
    public void UpdateBleDevicesListRssi()
    {
    	for (int i = 0; i < bleDevicesList.size(); i++) 
		{
    		bleDevicesList.get(i).setRssi(bleDevicesList.get(i).getBleDevice().getRssi());
		}
    }    

}
