package demoui.ble;

import com.example.passivebledemo.R;

import android.app.Dialog;
import android.content.Context;
import android.view.View;
import android.view.Window;
import android.widget.Button;
import android.widget.ListView;
import android.widget.ProgressBar;
import android.widget.TextView;

public class ListViewDialog extends Dialog implements android.view.View.OnClickListener {

    private final Context mContext;
    private ListView mListView;
    private TextView promptmsgText;
    private ProgressBar pBHelper;
    private Button button;
    
    private ListViewDialogButtonListener listener;
    
    public interface ListViewDialogButtonListener{   
        public void onClick(View view);   
    } 

    public ListViewDialog(Context context,ListViewDialogButtonListener listener) {
        super(context);
        mContext = context;
        this.listener = listener;
        initView();
    }

    private void initView() {
        View contentView = View.inflate(mContext, R.layout.activity_scan, null);
        button = (Button) contentView.findViewById(R.id.CancelBtn);
        button.setOnClickListener(this);
        promptmsgText = (TextView) contentView.findViewById(R.id.tv_promptmsg);
        pBHelper = (ProgressBar) contentView.findViewById(R.id.pB_helper);
        
        mListView = (ListView) contentView.findViewById(R.id.lv2);
        requestWindowFeature(Window.FEATURE_NO_TITLE);//ȥTitle
        setContentView(contentView);
    }

	public ListView getmListView() {
        return mListView;
    }

    public void setmListView(ListView mListView) {
        this.mListView = mListView;
    }
       
    public String getButtonText()
    {
    	return button.getText().toString();
    }
    
    public void setButtonText(String text)
    {
    	button.setText(text);
    }
    
    public void setPromptText(String text)
    {
    	promptmsgText.setText(text);
    }
    

    public void setProgressBarVisibility(int visibility)
    {
    	pBHelper.setVisibility(visibility);
    }
    
    
    @Override
    public void onClick(View v) {
        // TODO Auto-generated method stub
        listener.onClick(v);
    }
}

