package demoui.menu;

import android.graphics.drawable.Drawable;
/***˵Ŀʵ*/
public class MenuItem {
    private String itemKey;
    /**˵*/
    private String itemTitle=null;
    /**˵ͼ*/
    private Drawable itemIcon=null;
    /**ָ*/
    private boolean splitLine=false;
    /**switchͼ*/
    private boolean switchItem=false;
    /**switch״̬*/
    private boolean switchChecked=false;
    /**Ŀ״̬*/
    private boolean selected=false;
    /**Ŀ״̬*/
    private boolean visibility=true;
    /***/
    private boolean enabled=true;

    public interface OnMenuItemChange{
        /**
         * ĿԸıʱ
         * @param item ͸ıĲ˵
         * @param attributeName ı
         * @param value Ӧıֵ
         */
        void onChange(MenuItem item,String attributeName,Object value);
    }
    /**˵ı¼ӿ*/
    private OnMenuItemChange onMenuItemChange=null;
    /**
     * һйؼֵʵ
     * @param key ؼ
     */
    public MenuItem(String key){
        this.itemKey=key;
    }
    /**
     * һзָߵʵ
     * @param key ؼ
     * @param splitLine Ƿָ
     */
    public MenuItem(String key,boolean splitLine){
        this.itemKey=key;
        this.splitLine=splitLine;
        this.selected=false;
    }
    /**
     * ʵ
     * @param key ؼ
     * @param title
     */
    public MenuItem(String key,String title){
        this(key,title,null);
    }
    /**
     * һ⼰ͼʵ
     * @param key ؼ
     * @param title 
     * @param icon ͼ
     */
    public MenuItem(String key,String title,Drawable icon){
        this(key,title,icon,false);
    }
    /**
     * һ⣬ͼ꼰лͼʵ
     * @param key ؼ
     * @param title 
     * @param icon ͼ
     * @param switchItem лͼ
     */
    public MenuItem(String key,String title,Drawable icon,boolean switchItem){
        this(key,title,icon,switchItem,false);
    }
    /**
     * һ⣬ͼ꼰лͼʵ
     * @param key ؼ
     * @param title 
     * @param icon ͼ
     * @param switchItem лͼ
     * @param selected ѡ״̬
     */
    public MenuItem(String key,String title,Drawable icon,boolean switchItem,boolean selected){
        this.itemKey=key;
        this.itemTitle=title;
        this.itemIcon=icon;
        this.switchItem=switchItem;
        this.selected=selected;
    }
    /**
     * Ŀ
     * @param itemTitle
     */
    public void setItemTitle(String itemTitle) {
        if(this.isSplitLine()) {
            this.itemTitle = null;
        }else{
            if(this.itemTitle==null||this.itemTitle.length()==0) {
                if(itemTitle!=null && itemTitle.length()>0) {
                    this.itemTitle = itemTitle;
                    if (onMenuItemChange != null) {
                        onMenuItemChange.onChange(this, "itemTitle", itemTitle);
                    }
                }
            }else if(this.itemTitle!=null||this.itemTitle.length()>0){
                if(!this.itemTitle.equals(itemTitle)){
                    this.itemTitle = itemTitle;
                    if (onMenuItemChange != null) {
                        onMenuItemChange.onChange(this, "itemTitle", itemTitle);
                    }
                }
            }
        }
    }
    /**ȡĿ*/
    public String getItemTitle() {
        return itemTitle;
    }
    /**
     * Ŀͼ
     * @param itemIcon
     */
    public void setItemIcon(Drawable itemIcon) {
        if(this.isSplitLine()){
            this.itemIcon = null;
        }else {
            if(this.itemIcon==null && itemIcon!=null){
                this.itemIcon = itemIcon;
                if (onMenuItemChange != null) {
                    onMenuItemChange.onChange(this, "itemIcon", itemIcon);
                }
            }else if(this.itemIcon!=null && !this.itemIcon.equals(itemIcon)){
                this.itemIcon = itemIcon;
                if (onMenuItemChange != null) {
                    onMenuItemChange.onChange(this, "itemIcon", itemIcon);
                }
            }
        }
    }
    /**
     * ȡĿͼ
     * @return
     */
    public Drawable getItemIcon() {
        return itemIcon;
    }

    /**
     * ĿSwitch
     * @param switchItem
     */
    public void setSwitchItem(boolean switchItem) {
        if(this.isSplitLine()){
            this.switchItem =false;    //ĿΪָǽֹӵSwitch
        }else {
            if( this.switchItem != switchItem) {
                this.switchItem = switchItem;
                if (onMenuItemChange != null) {
                    onMenuItemChange.onChange(this, "switchItem", switchItem);
                }
            }
        }
    }
    /**Ŀwitch*/
    public boolean isSwitchItem() {
        return switchItem;
    }

    /**
     * Switchѡ״̬
     * @param switchChecked
     */
    public void setSwitchChecked(boolean switchChecked) {
        if(!this.isSwitchItem()){
            this.switchChecked =false;
        }else {
            if(this.switchChecked != switchChecked) {
                this.switchChecked = switchChecked;
//                if (onMenuItemChange != null) {
//                    onMenuItemChange.onChange(this, "switchChecked", switchChecked);
//                }
            }
        }
    }
    /**witchѡ״̬*/
    public boolean isSwitchChecked() {
        return switchChecked;
    }

    /**
     * Ŀѡ״̬
     * @param selected
     */
    public void setSelected(boolean selected) {
        if(this.isSplitLine()){
            this.selected = false;    //ĿΪָǽֹѡ
        }else{
            if(this.selected!=selected) {
                this.selected = selected;
                if (onMenuItemChange != null) {
                    onMenuItemChange.onChange(this, "selected", selected);
                }
            }
        }
    }
    /**Ŀѡ״̬*/
    public boolean isSelected() {
        return selected;
    }
    /**ĿǷָ*/
    public boolean isSplitLine() {
        return splitLine;
    }
    public void setItemKey(String key) {
        this.itemKey = key;
    }
    public String getItemKey() {
        return itemKey;
    }

    public void setVisibility(boolean visibility) {
        if(this.visibility!=visibility) {
            this.visibility = visibility;
            if (onMenuItemChange != null) {
                onMenuItemChange.onChange(this, "visibility", visibility);
            }
        }
    }

    public boolean isVisibility() {
        return visibility;
    }
    public void setEnabled(boolean enabled) {
        if(this.isSplitLine()) {
            this.enabled=true;
        }else{
            if (this.enabled != enabled) {
                this.enabled = enabled;
                if (onMenuItemChange != null) {
                    onMenuItemChange.onChange(this, "enabled", enabled);
                }
            }
        }
    }

    public boolean isEnabled() {
        return enabled;
    }
    /**
     * ò˵ıӿ
     * @param onMenuItemChange
     */
    public void setOnMenuItemChange(OnMenuItemChange onMenuItemChange) {
        this.onMenuItemChange = onMenuItemChange;
    }
}

