package com.example.passivebledemo;

import android.app.Activity;
import android.content.Context;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.TextView;
import tools.DemoConfig;
import tools.ShowToastUtils;

public class InventoryConfigActivity extends Activity implements OnClickListener {
	
	public static Context context;
	
    ////////////////////   ļ   ////////////////////////
	
	SharedPreferences mContextSp;
	SharedPreferences mActivitySp;
	
    ////////////////////   ؼ   ////////////////////////
	
	private static TextView titleCenterText;
	private static Button titleLeftBtn;
	
	////////////////////   ҳؼ   ////////////////////////
	
	//InventoryType Ⱥʽ
	private Spinner mSp_InventoryType;
	private int int_InventoryType = 0;
	
	private EditText accessPwdText,startAddrText,lenText;//롢ʼַ
	
	//¶ȱǩ
	private Spinner mSp_TempTagsType;
	private int int_TempTagsType = 0;
	
	Button inventoryConfigGetBtn,inventoryConfigSetBtn;
	
	
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		// TODO Auto-generated method stub
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_inventory_config);
		
		InitView();
		GetInventoryConfig();
	}
	
	
	/**
	 * ʼҳ
	 */
	public void InitView()
	{
		context = this;		
		LoadConfigClass();		
		InitTitle();
		
		//Ⱥʽ
		mSp_InventoryType = (Spinner) this.findViewById(R.id.sp_InventoryType);
		mSp_InventoryType.setOnItemSelectedListener(new Spinner.OnItemSelectedListener() {
			public void onItemSelected(AdapterView<?> arg0, View arg1, int arg2, long arg3) {
				int_InventoryType = arg2;
				mSp_InventoryType_OnSelectChanged();
			}

			public void onNothingSelected(AdapterView<?> arg0) {
				// TODO Auto-generated method stub
			}
		});
				
		//
		accessPwdText = (EditText) this.findViewById(R.id.et_AccessPwd);	
		//Userʼַ
		startAddrText = (EditText) this.findViewById(R.id.et_StartAddr);	
		//Userȡ
		lenText = (EditText) this.findViewById(R.id.et_Len);	
		
		//¶ȱǩ
		mSp_TempTagsType = (Spinner) this.findViewById(R.id.sp_TempTagsType);
		mSp_TempTagsType.setOnItemSelectedListener(new Spinner.OnItemSelectedListener() {
		    public void onItemSelected(AdapterView<?> arg0, View arg1, int arg2, long arg3) {
				int_TempTagsType = arg2;			
			}
			public void onNothingSelected(AdapterView<?> arg0) {
				// TODO Auto-generated method stub
			}
		});
		
		inventoryConfigGetBtn = (Button) this.findViewById(R.id.InventoryConfigGetBtn);
		inventoryConfigGetBtn.setOnClickListener(this);
		inventoryConfigSetBtn = (Button) this.findViewById(R.id.InventoryConfigSetBtn);
		inventoryConfigSetBtn.setOnClickListener(this);		
	}
	
	
	/**
	 * ʼ
	 */
	public void InitTitle()
	{
		//ť
		titleLeftBtn = (Button) this.findViewById(R.id.TitleLeftBtn);
		titleLeftBtn.setOnClickListener(this);
		
		//м
		titleCenterText = (TextView) this.findViewById(R.id.TitleCenterText);
	}
	
	
	/**
	 * ļ
	 */
	public void LoadConfigClass() 
	{
		mContextSp = this.getSharedPreferences("testContextSp", Context.MODE_PRIVATE);
		mActivitySp = this.getPreferences(Context.MODE_PRIVATE);
		mActivitySp.edit().commit();// only create file
	}
	
	
	@Override
	public void onClick(View v) 
	{
		switch (v.getId()) 
		{
		case R.id.TitleLeftBtn:
			finish();// ǰ棬һ	
			break;
		case R.id.InventoryConfigGetBtn:
			GetInventoryConfig();
			break;
		case R.id.InventoryConfigSetBtn:
			SetInventoryConfig();
			break;
		}		
	}
	
	
	public void GetInventoryConfig()
	{
		try
		{
			//Ⱥʽ
			int_InventoryType = mContextSp.getInt( "InventoryType", 0 );	
			mSp_InventoryType.setSelection(int_InventoryType);	
			//
			accessPwdText.setText(mContextSp.getString( "AccessPwd", "00000000" ));
			//Userʼַ
			startAddrText.setText(mContextSp.getString( "UserStartAddr", "0" ));
			//
			lenText.setText(mContextSp.getString( "UserLen", "6" ));
			//¶ȱǩ
			int_TempTagsType = mContextSp.getInt( "TempTagsType", 0 );	
			mSp_TempTagsType.setSelection(int_TempTagsType);	
			
			SetDemoInventoryConfig();
			
			ShowToastUtils.ShowToast(context,MainActivity.GetResourceString(R.string.Get) + 
					MainActivity.GetResourceString(R.string.InventoryConfig) + 
					MainActivity.GetResourceString(R.string.Success));
		}
		catch(Exception ex)
		{
			ShowToastUtils.ShowToast(context,MainActivity.GetResourceString(R.string.Get) + 
					MainActivity.GetResourceString(R.string.InventoryConfig) + 
					MainActivity.GetResourceString(R.string.Fail));
		}
	}
	

	
	public void SetInventoryConfig()
	{		
		try
		{
			 SharedPreferences.Editor editor = mContextSp.edit();		 
			 //Ⱥʽ
			 editor.putInt( "InventoryType", int_InventoryType);
			 //
			 if(accessPwdText.getText() != null && !accessPwdText.getText().toString().equals(""))
			 {
				 editor.putString( "AccessPwd", accessPwdText.getText().toString());
			 }	 
			 //Userʼַ
			 if(startAddrText.getText() != null && !startAddrText.getText().toString().equals(""))
			 {
				 editor.putString( "UserStartAddr", startAddrText.getText().toString());
			 }	
			 //
			 if(lenText.getText() != null && !lenText.getText().toString().equals(""))
			 {
				 editor.putString( "UserLen", lenText.getText().toString());
			 }	
			 //¶ȱǩ
			 editor.putInt( "TempTagsType", int_TempTagsType);
			 editor.commit();
			 
			 SetDemoInventoryConfig();
			 
			 ShowToastUtils.ShowToast(context,MainActivity.GetResourceString(R.string.Set) + 
						MainActivity.GetResourceString(R.string.InventoryConfig) + 
						MainActivity.GetResourceString(R.string.Success));
		}
		catch(Exception ex)
		{
			ShowToastUtils.ShowToast(context,MainActivity.GetResourceString(R.string.Set) + 
					MainActivity.GetResourceString(R.string.InventoryConfig) + 
					MainActivity.GetResourceString(R.string.Fail));
		}
	}
	

	
	public void SetDemoInventoryConfig()
	{
		//Ⱥʽ
		DemoConfig.InventoryTypeIndex = int_InventoryType;
		if(int_InventoryType == 0 || int_InventoryType == 1)//Ⱥorָ			
		{
			DemoConfig.IsReadUser = false;
			DemoConfig.IsReadTemp = false;
		}
		else if(int_InventoryType == 2)//UserȺ
		{
			DemoConfig.IsReadUser = true;
			DemoConfig.IsReadTemp = false;
		}
		else if(int_InventoryType == 3)//¶ȱǩ
		{
			DemoConfig.IsReadUser = false;
			DemoConfig.IsReadTemp = true;
		}
		 //
		 if(accessPwdText.getText() != null && !accessPwdText.getText().toString().equals(""))
		 {
			 DemoConfig.AccessPwd = accessPwdText.getText().toString();			 
		 }	
		 //Userʼַ
		 if(startAddrText.getText() != null && !startAddrText.getText().toString().equals(""))
		 {
			 DemoConfig.UserStartAddr = Integer.parseInt(startAddrText.getText().toString());		 
		 }	
		 //User
		 if(lenText.getText() != null && !lenText.getText().toString().equals(""))
		 {
			 DemoConfig.UserLen = Integer.parseInt(lenText.getText().toString());		 
		 }	
		 //¶ȱǩ
		 DemoConfig.TempTagsTypeIndex = int_TempTagsType; 
	}
	
	
    ///////////////////   ҳؼ¼   ////////////////////////
	
	/**
	 * Ⱥʽֵı¼
	 */
	public void mSp_InventoryType_OnSelectChanged()
	{
		if(int_InventoryType == 0)//Ⱥ
		{
			accessPwdText.setEnabled(false);
			startAddrText.setEnabled(false);
			lenText.setEnabled(false);
			mSp_TempTagsType.setEnabled(false);
		}
		else if(int_InventoryType == 1)//ָ 
		{
			accessPwdText.setEnabled(true);
			startAddrText.setEnabled(false);
			lenText.setEnabled(false);
			mSp_TempTagsType.setEnabled(false);
			
			ShowToastUtils.ShowToast(context,MainActivity.GetResourceString(R.string.PwdReadPrompt));
		}
		else if(int_InventoryType == 2)//UserȺ
		{
			accessPwdText.setEnabled(true);
			startAddrText.setEnabled(true);
			lenText.setEnabled(true);
			mSp_TempTagsType.setEnabled(false);
			
			ShowToastUtils.ShowToast(context,MainActivity.GetResourceString(R.string.UserReadPrompt));
		}
		else if(int_InventoryType == 3)//¶ȱǩ
		{
			accessPwdText.setEnabled(false);
			startAddrText.setEnabled(false);
			lenText.setEnabled(false);
			mSp_TempTagsType.setEnabled(true);
			
			ShowToastUtils.ShowToast(context,MainActivity.GetResourceString(R.string.TempReadPrompt));
		}
	}

    ///////////////////   ҳظ   ////////////////////////
	
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		if (item.getItemId() == android.R.id.home) finish();// ǰ棬һ		
		return true;
	}

}

