package com.example.passivebledemo;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Comparator;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import java.util.Timer;
import java.util.TimerTask;

import com.example.z_android_sdk.Reader;

import BlueTooth.BlueToothTypes;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Color;
import android.graphics.drawable.Drawable;
import android.media.AudioAttributes;
import android.media.AudioManager;
import android.media.SoundPool;
import android.os.Bundle;
import android.os.Handler;
import android.text.Spannable;
import android.text.SpannableString;
import android.text.SpannableStringBuilder;
import android.text.style.ForegroundColorSpan;
import android.text.style.ImageSpan;
import android.util.Log;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.Window;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.ListView;
import android.widget.PopupMenu;
import android.widget.TextView;
import android.widget.Toast;
import bleutils.BleHandle;
import bleutils.GpsPermission;
import android.widget.AdapterView.OnItemClickListener;
import demoui.ble.LoadingDialog;
import demoui.menu.DropMenu;
import demoui.tag.PassiveAdapter;
import tools.ConversionUtils;
import tools.DemoConfig;
import tools.SaveFileTools;
import tools.ShowToastUtils;
import tools.ValueHandleUtils;
import tools.dialogutils.DisConnectBleDeviceUtils;
import tools.dialogutils.PowerUtils;
import tools.dialogutils.SoundModeSelectUtils;
import tools.language.LanguageUtils;
import uhf.api.CommandType;
import uhf.api.Multi_TempTags;
import uhf.api.Multi_query_epc;
import uhf.api.Power;
import uhf.api.Version9200;
import uhf.api.Ware;
import uhfutils.SdkCallBackMethod;

public class MainActivity extends Activity implements OnClickListener {
	
	public static Context context;
	
    ////////////////////   ؼ   ////////////////////////
	
	public static TextView titleCenterText;
	private static Button titleLeftBtn,titleRightBtn;
	
	/**
	 * Ͻǲ˵
	 */
	DropMenu mDropMenu;

	////////////////////   ǩб   ////////////////////////
	
	private PassiveAdapter passiveAdapter;  
	private ListView TagsDataLV;
	Map<String, String> Map;
	private ArrayList<Map<String, String>> SourcereceptionArrayList = new ArrayList<Map<String, String>>();
	private ArrayList<Map<String, String>> receptionArrayList = new ArrayList<Map<String, String>>();
	private final String lvAdptrlabEPC = "EPC";
	private final String lvAdptrlabRssi = "Rssi";
	private final String lvAdptrlabTemp = "Temp";
	private final String lvAdptrlabCount = "Count";	
	private final String lvAdptrlabTid = "TID";
	private final String lvAdptrlabUserData = "User";
	 
	private final int Max_Tags_TempBuff = 2000;
	private String[][] tag_str_TagsData = new String[Max_Tags_TempBuff][];
	public static int tag_str_tmp_write = 0;
	public static int tag_str_tmp_Read = 0;
	
	//Ӧ
	public int tag_str_epc_index = 0;
	public int tag_str_rssi_index = 1;
	public int tag_str_temp_index = 2;
	public int tag_str_tid_index = 3;
	public int tag_str_user_index = 4;
	
	String[] StrLvTitleText = new String[] { lvAdptrlabEPC,lvAdptrlabRssi,lvAdptrlabTemp,lvAdptrlabTid,lvAdptrlabUserData };
	
	private Date curDate = null;// = new Date(System.currentTimeMillis());
	
	//----------------б˫------------------------
	
	private int lastClickId;// ˫¼¼һεID	
	private long lastClickTime;// ˫¼¼һεʱ	
	public static String ClickEPC = ""; //EPC	
	public static String ClickTID = ""; //TID
		
    ////////////////////   ҳؼ   ////////////////////////
	
	private static TextView batteryStatusText,moduleWorkStatusText,batteryVoltageText,
	tagsNumText,inventoryTimeAndSpeedText;
	
	private static Button inventoryBtn,stopInventoryBtn,clearBtn;//갴ťֹͣ갴ťʾť
	
	//---------صѹͼ---------
	
	SpannableString spanStringForEnough;// 
	SpannableString spanStringForMedium;// е
	SpannableString spanStringForLower;// ͵
	SpannableString spanStringForAlarm;// 澯
	
	////////////////////   RFID   ////////////////////////
	
	public static SdkCallBackMethod sdkCallBackMethod;
	public static Reader ReaderController;
	
    ////////////////////      ////////////////////////
	
	public static ValueHandleUtils valueHandleUtils;
	public static GpsPermission gpsPermission;
		
    /////////////////////////  ر   /////////////////////////
	
	BleHandle bleHandle;//Ƹ	
		
    ////////////////////   ʾ   //////////////////
	
	public static LoadingDialog mLoadingDialog;
	

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
//		requestWindowFeature(Window.FEATURE_CUSTOM_TITLE);		
		LanguageUtils.getInstance(this).switchLanguage(LanguageUtils.getInstance(this).GetLanguageLocale());
//		LanguageUtils.getInstance(this).switchLanguage(Locale.ENGLISH);	
		setContentView(R.layout.activity_main);
//		getWindow().setFeatureInt(Window.FEATURE_CUSTOM_TITLE, R.layout.activity_title);
		
		InitView();
		InitHelperHandleClass();
		
		LoadService();		
	}
	
	/**
	 * Ϣ-̨
	 */
	public void LoadService() 
	{
		Intent intent = new Intent(MainActivity.this, MyService.class);
		startService(intent);
	}
	
	/**
	 * ʼҳ
	 */
	public void InitView()
	{
		context = this;
		ReadDemoConfig();
		
		InitTitle();
		InitSpannableStringIcon();
		
		((TextView) this.findViewById(R.id.InventoryTimeAndSpeedText)).setText(
				GetResourceString(R.string.Time) +"-" + "MS" + " " 
		+ GetResourceString(R.string.Speed) + "-" + GetResourceString(R.string.Units));//ʱٶ
		
		//豸״̬
		batteryStatusText = (TextView) this.findViewById(R.id.BatteryStatusText);
		
		//ģ鹤״̬
		moduleWorkStatusText = (TextView) this.findViewById(R.id.ModuleWorkStatusText);
		
		//豸ص
		batteryVoltageText = (TextView) this.findViewById(R.id.BatteryVoltageText);
		
		//ǩ
		tagsNumText = (TextView) this.findViewById(R.id.TagsNumText);
		
		//ʱ&ٶ
		inventoryTimeAndSpeedText = (TextView) this.findViewById(R.id.InventoryTimeAndSpeedText);
		
		//ǩб
		TagsDataLV = (ListView) findViewById(R.id.lvReception);
		passiveAdapter = new PassiveAdapter(this, receptionArrayList, R.layout.list_passive_tags,
				new String[] { lvAdptrlabEPC, lvAdptrlabRssi,lvAdptrlabTemp,lvAdptrlabCount,lvAdptrlabTid,
				               lvAdptrlabUserData},
				new int[] { R.id.Text_Epc,R.id.Text_Rssi,
						    R.id.Text_Temperature,R.id.Text_Count,
						    R.id.Text_Tid,R.id.Text_User});
		TagsDataLV.setAdapter(passiveAdapter);
		TagsDataLV.setOnItemClickListener(new OnItemClickListener() {
			@Override
			public void onItemClick(AdapterView<?> parent, View view, int position, long id) {				
				Lv_TagsData_Clicked(position);
			}
		});
		
		//ʼѭ
		inventoryBtn = (Button) findViewById(R.id.InventoryBtn);
		inventoryBtn.setOnClickListener(this);
		
		//ֹͣѭ
		stopInventoryBtn = (Button) findViewById(R.id.StopInventoryBtn);
		stopInventoryBtn.setOnClickListener(this);
		
		//ʾ
		clearBtn = (Button) findViewById(R.id.ClearBtn);
		clearBtn.setOnClickListener(this);
		
		showMessage(StrLvTitleText, 0, true);		
	}
	
	protected void onDestroy() 
	{
		ExitDemo();
		super.onDestroy();
	}	
	
	/**
	 * ʼ
	 */
	public void InitTitle()
	{
		//ť
		titleLeftBtn = (Button) this.findViewById(R.id.TitleLeftBtn);
		titleLeftBtn.setOnClickListener(this);
		
		//м
		titleCenterText = (TextView) this.findViewById(R.id.TitleCenterText);
		
		//Ұť
		titleRightBtn = (Button) this.findViewById(R.id.TitleRightBtn);
		titleRightBtn.setOnClickListener(this);
				
		mDropMenu = new DropMenu(this, titleRightBtn); // thisΪģbtnPopMenuҪ˵ĶλͼԸͼΪԲ㶨λ
		// Ӳ˵
		mDropMenu.addMenuItem("AccessTag", GetResourceString(R.string.AccessTag));
		mDropMenu.addSplitLine();
		mDropMenu.addMenuItem("PowerConfig", GetResourceString(R.string.PowerConfig));
		mDropMenu.addSplitLine();
		mDropMenu.addMenuItem("MultiConfig",GetResourceString(R.string.MultiConfig));
		mDropMenu.addSplitLine();
		mDropMenu.addMenuItem("RfidConfig",GetResourceString(R.string.RfidConfig));
		mDropMenu.addSplitLine();
		mDropMenu.addMenuItem("TagsSound",GetResourceString(R.string.TagsSound));
		mDropMenu.addSplitLine();
		mDropMenu.addMenuItem("SaveTxt",GetResourceString(R.string.SaveTxt));	
		
		mDropMenu.setOnMenuItemClickListener(menuItemClickListener); // ˵Ŀ¼
		mDropMenu.setMenuItemBackgroundColor(Color.parseColor("#515151"));// ò˵Ŀɫ
		mDropMenu.setMenuItemTextColor(Color.parseColor("#dbdbdb"));// ò˵ɫ
//		mDropMenu.setSplitLineColor//÷ָɫ
	}
	
	
	/**
	 * ʼصصͼ
	 */
	public void InitSpannableStringIcon()
	{
		// ICONͼ
		ImageSpan imgSpan = new ImageSpan(this, R.drawable.voltageforenough, ImageSpan.ALIGN_BOTTOM);
		spanStringForEnough = new SpannableString("icon");
		spanStringForEnough.setSpan(imgSpan, 0, spanStringForEnough.length(), Spannable.SPAN_EXCLUSIVE_EXCLUSIVE);
		// еICONͼ
		imgSpan = new ImageSpan(this, R.drawable.voltageformedium, ImageSpan.ALIGN_BOTTOM);
		spanStringForMedium = new SpannableString("icon");
		spanStringForMedium.setSpan(imgSpan, 0, spanStringForMedium.length(), Spannable.SPAN_EXCLUSIVE_EXCLUSIVE);
		// ͵ICONͼ
		imgSpan = new ImageSpan(this, R.drawable.voltageforlower, ImageSpan.ALIGN_BOTTOM);
		spanStringForLower = new SpannableString("icon");
		spanStringForLower.setSpan(imgSpan, 0, spanStringForLower.length(), Spannable.SPAN_EXCLUSIVE_EXCLUSIVE);
		// ICONͼ
		imgSpan = new ImageSpan(this, R.drawable.voltageforalarm, ImageSpan.ALIGN_BOTTOM);
		spanStringForAlarm = new SpannableString("icon");
		spanStringForAlarm.setSpan(imgSpan, 0, spanStringForAlarm.length(), Spannable.SPAN_EXCLUSIVE_EXCLUSIVE);
	}
	
	
	/**
	 * ȡDemo
	 */
	public void ReadDemoConfig()
	{
		valueHandleUtils = new ValueHandleUtils(this);
		valueHandleUtils.GetDemoConfig();	
	}
	
	/**
	 * ʼظ
	 */
	public void InitHelperHandleClass()
	{
		LoadSoundPool();	
		LoadRfidHandle();
		
		mLoadingDialog = new LoadingDialog(this);
		
		//GPSλϢ
		gpsPermission = new GpsPermission(this);			
		//
		bleHandle = new BleHandle(context,ReaderController);
		bleHandle.InitBlueToothAdapter();
		
		if(!gpsPermission.getGpsLocationPermissionState()) 
		{
			gpsPermission.ShowOpenGpsLocationToast();	
			return;
		}
		
		//Ƿѿ
		if(!bleHandle.BlueToothState()) 
		{
			bleHandle.OpenBlueTooth();
			ShowToastUtils.ShowToast(context,GetResourceString(R.string.CheckBleForClosePrompt));
			return;
		}
		
		//ɨӶ״Զϴ豸  
		bleHandle.ResetListViewDialogAndScanBle();
		bleHandle.StartScanBlueToothDevice();
	}
	

	/**
	 * 
	 */
	public void LoadSoundPool()
	{
		 // 5.0  ֮
        if (android.os.Build.VERSION.SDK_INT >= android.os.Build.VERSION_CODES.LOLLIPOP) 
        {
            AudioAttributes audioAttributes = new AudioAttributes.Builder()
                    .setUsage(AudioAttributes.USAGE_MEDIA)
                    .setContentType(AudioAttributes.CONTENT_TYPE_MUSIC)
                    .build();
            SoundModeSelectUtils.soundPool = new SoundPool.Builder()
                    .setMaxStreams(10)
                    .setAudioAttributes(audioAttributes)
                    .build();
        } 
        else // 5.0 ǰ
        { 
        	SoundModeSelectUtils.soundPool = new SoundPool(10, AudioManager.STREAM_SYSTEM, 0);
        }
        SoundModeSelectUtils.soundPool.load(this,R.raw.beep, 1);
		AudioManager mAudioManager = (AudioManager) getSystemService(Context.AUDIO_SERVICE);
	}
	
	
	/**
	 * RFID
	 */
	public void LoadRfidHandle()
	{
		SoundThreadStart();
		PassiveTagsHandleThreadStart();
				
		sdkCallBackMethod = new SdkCallBackMethod(this);
		ReaderController = sdkCallBackMethod.ReaderController;
	}
	

	@Override
	public void onClick(View v) 
	{
		switch (v.getId()) 
		{
		case R.id.TitleLeftBtn:
			BleConnectAction();
			break;
		case R.id.TitleRightBtn:
			mDropMenu.show();
			break;
		case R.id.InventoryBtn:
			StartInventoryBtnClickMethod();
			break;
		case R.id.StopInventoryBtn:
			StopInventoryBtnClickMethod();
			break;
		case R.id.ClearBtn:
			showDataClear();
			break;
		}	
	}

	  
	/**
	 * orϿ
	 */
	public void BleConnectAction()
	{
		String bleConnectStateStr = titleLeftBtn.getText().toString();
		
		if(bleConnectStateStr.equals(GetResourceString(R.string.Connected)))//
		{
			//ȷǷϿ
			DisConnectBleDeviceUtils.DisConnectBleDeviceDialog(context,bleHandle.actionBleDevice.getName());
		}
		else//δ
		{
			//Ƿѿ		
			if(!bleHandle.BlueToothState()) 
			{
				bleHandle.isFirstConnect = false;
				bleHandle.OpenBlueTooth();
				ShowToastUtils.ShowToast(context,GetResourceString(R.string.CheckBleForClosePrompt));
				return;
			}			
			
			//鰲׿GPSλϢǷ
			if(!gpsPermission.getGpsLocationPermissionState()) 
			{
				bleHandle.isFirstConnect = false;
				gpsPermission.ShowOpenGpsLocationToast();	
				return;
			}
			
			bleHandle.ResetListViewDialogAndScanBle();
			bleHandle.StartScanBlueToothDevice();
		}
	}
	
	/**
	 * ʼѭťִк
	 */
	public void StartInventoryBtnClickMethod()
	{		
		ReadTagsSpeedNum = 0;//ٶȸ
		
		Multi_query_epc mMulti_query_epc;
		Multi_TempTags mMulti_temptags;
	    switch(DemoConfig.InventoryTypeIndex)
	    {
	    case 0://Ⱥ
	    	mMulti_query_epc = new Multi_query_epc();
			mMulti_query_epc.query_total = 0;
			ReaderController.UHF_CMD(CommandType.MULTI_QUERY_TAGS_EPC, mMulti_query_epc);
	    	break;
	    case 1://ָȺ
	    	mMulti_query_epc = new Multi_query_epc();
			mMulti_query_epc.query_total = 0;
			mMulti_query_epc.inventory_type = 0x06;
			mMulti_query_epc.access_pwd = DemoConfig.AccessPwd;		
			ReaderController.UHF_CMD(CommandType.MULTI_QUERY_TAGS_EPC, mMulti_query_epc);
	    	break;
	    case 2://UserȺ	    	    	
	    	mMulti_query_epc = new Multi_query_epc();
			mMulti_query_epc.query_total = 0;
			mMulti_query_epc.access_pwd = DemoConfig.AccessPwd;
			mMulti_query_epc.user_Len = (byte)DemoConfig.UserLen;
			
	    	if(DemoConfig.UserStartAddr <= 255)
	    	{	    		
				mMulti_query_epc.inventory_type = 0x08;			
				mMulti_query_epc.user_startAddr = (byte)DemoConfig.UserStartAddr;
	    	}
	    	else
	    	{
				mMulti_query_epc.inventory_type = 0x09;
				mMulti_query_epc.Int_User_startAddr = DemoConfig.UserStartAddr;			
	    	}
	    	ReaderController.UHF_CMD(CommandType.MULTI_QUERY_TAGS_EPC, mMulti_query_epc);	    	
	    	break;
	    case 3://¶ȱǩ
	    	mMulti_temptags = new Multi_TempTags();
	    	if(DemoConfig.TempTagsTypeIndex == 0)//LTU27
	    	{	    		 
	    		 mMulti_temptags.TempTagsType = 0x01;
	    	}
	    	else if(DemoConfig.TempTagsTypeIndex == 1)//LTU3x
	    	{
	    		mMulti_temptags.TempTagsType = 0x02;
	    	}
	    	else if(DemoConfig.TempTagsTypeIndex == 2)//RFM
	    	{
	    		 mMulti_temptags.TempTagsType = (byte)0x20;
	    	}
	    	else if(DemoConfig.TempTagsTypeIndex == 3)//NMV2D
	    	{
	    		 mMulti_temptags.TempTagsType = (byte)0x30;
	    	}
	    	ReaderController.UHF_CMD(CommandType.Read_TagTemp_Start, mMulti_temptags);
	    	break;
	    }

	    titleCenterText.setText(GetResourceString(R.string.ReadingTags));	
		InventoryTimerStart();
		
		curDate = new Date(System.currentTimeMillis());				
		inventoryBtn.setEnabled(false);
	}
	
	
	/**
	 * ֹͣѭťִк
	 */
	public void StopInventoryBtnClickMethod()
	{
		Multi_TempTags mMulti_temptags;
		switch (DemoConfig.InventoryTypeIndex) 
		{
		case 0:
		case 1:
		case 2:
			Boolean ret = ReaderController.UHF_CMD(CommandType.STOP_MULTI_QUERY_TAGS_EPC, null);
			if (!ret) ReaderController.UHF_CMD(CommandType.STOP_MULTI_QUERY_TAGS_EPC, null);
			break;
		case 3:
			mMulti_temptags = new Multi_TempTags();
	    	if(DemoConfig.TempTagsTypeIndex == 0)//LTU27
	    	{	    		 
	    		 mMulti_temptags.TempTagsType = 0x01;
	    	}
	    	else if(DemoConfig.TempTagsTypeIndex == 1)//LTU3x
	    	{
	    		mMulti_temptags.TempTagsType = 0x02;
	    	}
	    	else if(DemoConfig.TempTagsTypeIndex == 2)//RFM
	    	{
	    		 mMulti_temptags.TempTagsType = (byte)0x20;
	    	}
	    	else if(DemoConfig.TempTagsTypeIndex == 3)//NMV2D
	    	{
	    		 mMulti_temptags.TempTagsType = (byte)0x30;
	    	}
	    	ReaderController.UHF_CMD(CommandType.Read_TagTemp_Stop, mMulti_temptags);
			break;
		}
		
		NewTagFlag = 0;//귢0
		titleCenterText.setText("Stop Ok");
		InventoryTimerStop();
		
		inventoryBtn.setEnabled(true);
	}
	
	
	/**
	 * ʾ
	 */
	private void showDataClear() 
	{
		String countMessage = GetResourceString(R.string.TagsNum) + "0";
		tagsNumText.setText(countMessage);
		inventoryTimeAndSpeedText.setText(GetResourceString(R.string.Time) +"00:00:00.000" 
		+ GetResourceString(R.string.Speed) + "- " + GetResourceString(R.string.Units));	
		tag_str_tmp_Read = tag_str_tmp_write = NewTagFlag = 0;
		receptionArrayList.clear();
		SourcereceptionArrayList.clear();
		showMessage(StrLvTitleText, 0, true);
		passiveAdapter.notifyDataSetChanged();
		curDate = new Date(System.currentTimeMillis());				
		ReadTagsTime = ReadTagsSpeedNum = 0;	
	}
	
	
	////////////////////      ////////////////////////
	
	
	/**
	 * 豸״̬
	 */
	public void UpdateBleConnectDeviceState(final int blueToothTypes) 
	{
		this.runOnUiThread(new Runnable() {
			@Override
			public void run() {
				
				bleHandle.isFirstConnect = false;
				switch (blueToothTypes) 
				{
				case BlueToothTypes.CONNECT_SUCCESS: // ӳɹ
					Log.e("BlueTooth", "ӳɹ");
					break;
				case BlueToothTypes.NOTIFY_SUCCESS: // 豸
					bleHandle.bleConnectState = true;		
					Log.e("BlueTooth", "豸");
					mLoadingDialog.dismiss();					
					ShowToastUtils.ShowToast(context,GetResourceString(R.string.ConnectSuccess));
					//MACַԱ´
					valueHandleUtils.SetLastConnectBleMac(bleHandle.actionBleDevice.getMac());		
					
					Drawable drawable= getResources().getDrawable(R.drawable.connect); /// һҪ,򲻻ʾ. 
					drawable.setBounds(0, 0, drawable.getMinimumWidth(), drawable.getMinimumHeight()); 
					titleLeftBtn.setCompoundDrawables(drawable,null,null,null);
					titleLeftBtn.setText(GetResourceString(R.string.Connected));
					titleLeftBtn.setTextColor(Color.parseColor("#0e7c28"));					
					UpdateViewControlEnabled(true);
					
					GetModuleVersionAndPowerRange();//ȡģ汾ʷΧ
					break;
				case BlueToothTypes.NOTIFY_FAIL:// ޷豸ݣʾûֻ
					Log.e("BlueTooth", "޷豸ͨѶֻ");
					mLoadingDialog.dismiss();
					ShowToastUtils.ShowToast(context,GetResourceString(R.string.RestartBluetoothPrompt));
					break;
				}

			}
		});
	}
	
	
	/**
	 * 豸Ͽӣ½
	 */
	public void DisConnectBleDevice()
	{
		bleHandle.bleConnectState = false;		
		bleHandle.DisConnectBleDevice(bleHandle.actionBleDevice);//Ͽ
		bleHandle.actionBleDevice = null;
		
		Drawable drawable= getResources().getDrawable(R.drawable.disconnect); /// һҪ,򲻻ʾ. 
		drawable.setBounds(0, 0, drawable.getMinimumWidth(), drawable.getMinimumHeight()); 
		titleLeftBtn.setCompoundDrawables(drawable,null,null,null);
		titleLeftBtn.setText(GetResourceString(R.string.DisConnected));
		titleLeftBtn.setTextColor(Color.parseColor("#c52814"));		
		UpdateViewControlEnabled(false);
		
		titleCenterText.setText("");
		batteryStatusText.setText(GetResourceString(R.string.BatteryStatus));
		batteryStatusText.setTextColor(Color.parseColor("#ebedec"));		
		moduleWorkStatusText.setText(GetResourceString(R.string.ModuleWorkStatus));
		moduleWorkStatusText.setTextColor(Color.parseColor("#ebedec"));		
		batteryVoltageText.setText(GetResourceString(R.string.BatteryVoltage));
		batteryVoltageText.setTextColor(Color.parseColor("#ebedec"));		
		
		showDataClear();
	}
	
	
	/**
	 * ťƶ
	 */
	public void UpdateMultiTagsAction(final int multiValue)
	{
		this.runOnUiThread(new Runnable() {
			@Override
			public void run() {
				
				Log.i("UpdateMultiTagsAction", multiValue + "");
				
				////0:ֹͣ 1:ʼ
				if(multiValue == 0) StopInventoryBtnClickMethod();
				else StartInventoryBtnClickMethod();		
				
			}
		});
	}
	
	
    /**
     * ֱ״̬ģ鹤״ֱ̬ص
     */
	public void UpdateBleDeviceMessage(final int voltage, final byte BatteryStatus,final byte ModuleWorkStatus,
			final int Voltseg2, final int Voltseg1,final int Voltseg0)
	{
		//ֱ״̬=澯ڳ
		//ģ鹤״̬=ȴ
		//ֱص=㣬еȣ͵ȣ澯		
		this.runOnUiThread(new Runnable() {
			@Override
			public void run() {
				
				UpdateBatteryStatusText(BatteryStatus);
				UpdateModuleWorkStatusText(ModuleWorkStatus);
				UpdateBatteryVoltageText(voltage,Voltseg2,Voltseg1,Voltseg0);
				
			}
		});			
	}
	
	
	/**
	 * ֱ״̬
	 */
	public void UpdateBatteryStatusText(byte BatteryStatus)
	{
		if(BatteryStatus != (byte)0xFF)
		{
			String Bin2Str = String.format("%8s", Integer.toBinaryString(BatteryStatus & 0xFF)).replace(' ', '0');
			String Bit1 = Bin2Str.substring(6, 7);
			String Bit0 = Bin2Str.substring(7, 8);
			
			switch (Bit0) 
			{
			case "0":// شڷŵ״̬  
				if (Bit1.equals("0")) // 
				{					
					batteryStatusText.setText(GetResourceString(R.string.BatteryStatusForNormal));
					batteryStatusText.setTextColor(Color.GREEN);
				} 
				else // 澯
				{
					batteryStatusText.setText(GetResourceString(R.string.BatteryStatusForAlarm));
					batteryStatusText.setTextColor(Color.RED);
				}
				break;
			case "1":// شڳ״̬
				if (Bit1.equals("0")) // 
				{
					batteryStatusText.setText(GetResourceString(R.string.BatteryStatusForChargingFull));
					batteryStatusText.setTextColor(Color.GREEN);
				} 
				else// ڳ
				{
					batteryStatusText.setText(GetResourceString(R.string.BatteryStatusForIsCharging));
					batteryStatusText.setTextColor(Color.GREEN);
				}
				break;
			default:
				break;
			}
		}		
	}
	
	
	/**
	 * ģ鹤״̬
	 * @param ModuleWorkStatus
	 */
	public void UpdateModuleWorkStatusText(byte ModuleWorkStatus)
	{
		if (ModuleWorkStatus != (byte) 0xFF)
		{
			String Bin2Str = String.format("%8s", Integer.toBinaryString(ModuleWorkStatus & 0xFF)).replace(' ', '0');
			String Bit0 = Bin2Str.substring(7, 8);

			if (Bit0.equals("0")) // Ⱥ״̬
			{
				moduleWorkStatusText.setText(GetResourceString(R.string.ModuleWorkStatusForWait));
			} 
			else // ״̬	
			{		
				moduleWorkStatusText.setText(GetResourceString(R.string.ModuleWorkStatusForRead));
			}
		}
	}
	
	
	/**
	 * ֱص
	 */
	public void UpdateBatteryVoltageText(int voltage, int Voltseg2, int Voltseg1, int Voltseg0)
	{
		double voltageCalculate = voltage / 1000.0;
		
		if (voltage > Voltseg2) //
		{			
			//ֱص: + iconͼ
			batteryVoltageText.setText(GetResourceString(R.string.BatteryVoltage));
			batteryVoltageText.append(spanStringForEnough);
			batteryVoltageText.append(GetResourceString(R.string.BatteryVoltageForEnough) + "[" + voltageCalculate + "]");
			batteryVoltageText.setTextColor(Color.GREEN);
		} 
		else if (Voltseg1 < voltage && voltage < Voltseg2) //е
		{		
			batteryVoltageText.setText(GetResourceString(R.string.BatteryVoltage));	
			batteryVoltageText.append(spanStringForMedium);
			batteryVoltageText.append(GetResourceString(R.string.BatteryVoltageForMedium) + "[" + voltageCalculate + "]");
			batteryVoltageText.setTextColor(Color.YELLOW);
		} 
		else if (Voltseg0 < voltage && voltage < Voltseg1) //͵
		{
			batteryVoltageText.setText(GetResourceString(R.string.BatteryVoltage));	
			batteryVoltageText.append(spanStringForLower);
			batteryVoltageText.append(GetResourceString(R.string.BatteryVoltageForLower) + "[" + voltageCalculate + "]");
			batteryVoltageText.setTextColor(Color.parseColor("#FF8C00"));
		} 
		else if (voltage < Voltseg0) 
		{
			batteryVoltageText.setText(GetResourceString(R.string.BatteryVoltage));	
			batteryVoltageText.append(spanStringForAlarm);
			batteryVoltageText.append(GetResourceString(R.string.BatteryVoltageForAlarm) + "[" + voltageCalculate + "]");
			batteryVoltageText.setTextColor(Color.RED);
		}
	}
	
	
	/**
	 * ҳؼ״̬
	 */
	public void UpdateViewControlEnabled(Boolean enabled)
	{
		inventoryBtn.setEnabled(enabled);
		stopInventoryBtn.setEnabled(enabled);
		clearBtn.setEnabled(enabled);	
		titleRightBtn.setEnabled(enabled);
	}
	
	////////////////////   ȡģ汾 & ȡģ鹦ʷΧ   ////////////////////////
	
	
	public static String MajorVersion = "";
	/**
	 * ѯģ汾
	 */
	public void GetModuleVersionAndPowerRange() 
	{
		Handler handler = new Handler();
		handler.postDelayed(new Runnable() {
			public void run() {
				Ware mWare = new Ware(CommandType.GET_FIRMWARE_VERSION, 0, 0, 0);
				int count = 0;
				while (true) {
					Boolean ret = ReaderController.UHF_CMD(CommandType.GET_FIRMWARE_VERSION, mWare);
					if (ret) {
						MajorVersion = mWare.major_version + "";
						String Str_Ver = "Ver" + ConversionUtils.IntToHexString_Ver(mWare.major_version) + "." 
						                + ConversionUtils.IntToHexString_Ver(mWare.minor_version) + "." + ConversionUtils.IntToHexString_Ver(mWare.revision_version);
						titleCenterText.setText(GetResourceString(R.string.GetModuleVersionSuccess) + Str_Ver);							
						
						if(MajorVersion.equals("2")) GetPowerRangeThreadStart();// ѯģ鹦ʷΧ				
						break;
					}
					count++;
					if (count > 1) {
						titleCenterText.setText(GetResourceString(R.string.GetModuleVersionFail));
						break;
					}
				}
			}
		}, 300);
	}
	
	/**
	 * ѯģ鹦
	 */
	public void GetModulePower() 
	{
		Handler handler = new Handler();
		handler.postDelayed(new Runnable() {
			public void run() {
				Power mPower = new Power();
				mPower.com_type = CommandType.GET_POWER;
				mPower.loop = 0;
				mPower.read = 0;
				mPower.write = 0;
				int count = 0;
				while (true) {
					Boolean ret = ReaderController.UHF_CMD(CommandType.GET_POWER, mPower);
					if (ret) {
						PowerUtils.NowPowerValue = mPower.read;
						ShowToastUtils.ShowToast(context,GetResourceString(R.string.Get) + 
								GetResourceString(R.string.Power) + GetResourceString(R.string.Success) + ":" + mPower.read + "dBm");						
						break;
					}
					count++;
					if (count > 3) {
						ShowToastUtils.ShowToast(context,GetResourceString(R.string.Get) + 
								GetResourceString(R.string.Power) + GetResourceString(R.string.Fail));		
						break;
					}
				}				
			}
		}, 300);
	}
	
	
	/**
	 * ģ鹦
	 * @param ReadPower
	 */
	public void SetModulePower(int ReadPower) 
	{
		Power mPower = new Power();
		mPower.com_type = CommandType.SET_POWER;
		mPower.loop = 0;
		mPower.read = ReadPower;
		mPower.write = ReadPower;

		Boolean ret = ReaderController.UHF_CMD(CommandType.SET_POWER, mPower);
		if (ret) 
		{
			PowerUtils.NowPowerValue = ReadPower;
			titleCenterText.setText(GetResourceString(R.string.Set) + GetResourceString(R.string.Power) + GetResourceString(R.string.Success)+ ":" + ReadPower + "dBm");					
			//mSound.callAlarm(true, 100);
		} 
		else 
		{
			titleCenterText.setText(GetResourceString(R.string.Set) + GetResourceString(R.string.Power) + GetResourceString(R.string.Fail));		
			//mSound.callAlarm(false, 100);
		}
	}
	
    ///////////////////// ȡģ鹦ʷΧ ///////////////////////////////
	
	/** 
	 * ߳ ѯģ鹦ʷΧ
	 */
	private void GetPowerRangeThreadStart() {
		if (GetPowerRangeThread == null) {
			GetPowerRangeThread = new GetPowerRangeThread();
			GetPowerRangeThread.start();
		}
	}
	
	private GetPowerRangeThread GetPowerRangeThread;
	private class GetPowerRangeThread extends Thread {
		public void run() {
			try
			{
				Thread.sleep(500);
				GetPowerRange();		
			}
			catch(Exception ex){
				
			}
		};
	};
	
	
	/**
	 * ѯģ鹦ʷΧ
	 */
	public void GetPowerRange() 
	{
		Version9200 ver = new Version9200();
		ver.com_type = CommandType.GET_MODULE_VERSION_9200;
		ver.RssiState = (byte) 0x00;
		int count = 0;
		try 
		{
			Boolean ret = ReaderController.UHF_CMD(CommandType.GET_MODULE_VERSION_9200, ver);
			if (ret) 
			{
				if (CommandType.MODULE_VERSION_9200_POWER == (byte) 0x15) //15-25
				{
					PowerUtils.PowerMinValue = 15;
					PowerUtils.PowerMaxValue = 25;	
				}
				if (CommandType.MODULE_VERSION_9200_POWER == (byte) 0x25) //5-25
				{
					PowerUtils.PowerMinValue = 5;
					PowerUtils.PowerMaxValue = 25;	
				}
				if (CommandType.MODULE_VERSION_9200_POWER == (byte) 0x30) //20-30
				{
					PowerUtils.PowerMinValue = 20;
					PowerUtils.PowerMaxValue = 30;	
				}
				if (CommandType.MODULE_VERSION_9200_POWER == (byte) 0x00) //5-30
				{
					PowerUtils.PowerMinValue = 5;
					PowerUtils.PowerMaxValue = 30;	
				}
			} 
			else 
			{
				PowerUtils.PowerMinValue = 5;
				PowerUtils.PowerMaxValue = 36;	
			}
			
			PowerUtils.st_power_range = new String[PowerUtils.PowerMaxValue - PowerUtils.PowerMinValue + 1];
			for(int i = PowerUtils.PowerMinValue;i<=PowerUtils.PowerMaxValue;i++)
				PowerUtils.st_power_range[i - PowerUtils.PowerMinValue] = i + "";
			
		} catch (Exception ex) {

		}
	}
	
	///////////////////// ǩݴ ///////////////////////////////
	
	//----------귢----------
	
	/**
	 * ߳
	 */
	private void SoundThreadStart() {
		if (Soundthread == null) {
			Soundthread = new SoundThread();
			Soundthread.start();
		}
	}

	/**
	 * ֹͣ߳
	 */
	private void SoundThreadStop() {
		if (Soundthread != null) {
			Soundthread.stop = true;
			Soundthread = null;
		}
	}
	
	/**
	 * 귢־
	 */
	public static int NewTagFlag = 0;
	
	private SoundThread Soundthread;
	private class SoundThread extends Thread {
		public boolean stop;
		public void run() {
			while (!stop) {
				// 
				// ͨ˯߳öʱʱ ???
				try 
				{
					Thread.sleep(40);
					if (NewTagFlag > 25) NewTagFlag = 25;// һ25Σ󣬶ʱ
					
					if (NewTagFlag > 0) 
					{
						NewTagFlag--;
						SoundModeSelectUtils.soundPool.play(1, (float)0.6, (float)0.6, 1, 0, 1);
					}												
				} 
				catch (InterruptedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		};
	};

	
	//----------ٶȡʱ----------
	
    public Boolean IsTimerFirstRun = true;
	
    /**
     * ̴ʱٶȶʱ
     */
	public void InventoryTimerStart() {
		if (inventoryTimer == null) {
			IsAssignLastSpeed = false;
			LastSpeedNum = TimerRunCount = 0;
			IsTimerFirstRun = true;
			inventoryTimer = new Timer();
			InventoryTimerRunMethod();
		}
	}
	
	/**
	 * ̴ֹͣʱٶȶʱ
	 */
	public void InventoryTimerStop() {
		if (inventoryTimer != null) {
			inventoryTimer.cancel();
			inventoryTimer = null;
		}
	}
	
	/**
	 * ǷLastSpeedNumֵ
	 */
	public Boolean IsAssignLastSpeed = false;
	public int LastSpeedNum = 0;
	/**
	 * ʱִд
	 */
	public int TimerRunCount = 0;
	
	public int ReadTagsTime = 0;
	public int ReadTagsSpeedNum = 0;
	
	
	// ٶȡʱʱ
	Timer inventoryTimer = null;   
	public void InventoryTimerRunMethod() {
		inventoryTimer.schedule(new TimerTask() {
			@Override
			public void run() {
				InventoryTimerMethod();
			}
		}, 100, 100);
	}
	
	
	public void InventoryTimerMethod()
	{
		if (!IsTimerFirstRun) 
		{
			ReadTagsTime = ReadTagsTime + 100;
			TimerRunCount++;				

			if (TimerRunCount < 10) 
			{								
				String strMsg = "";
				if(!IsAssignLastSpeed)//δLastSpeedNumֵʾٶ
				{
					strMsg = GetResourceString(R.string.Time) + ConversionUtils.msecToTime(ReadTagsTime) + GetResourceString(R.string.Speed)
							+ "-" + GetResourceString(R.string.Units);
				}
				else
				{
					strMsg = GetResourceString(R.string.Time) + ConversionUtils.msecToTime(ReadTagsTime) + GetResourceString(R.string.Speed)
							+ LastSpeedNum + GetResourceString(R.string.Units);
				}
				UpdateInventoryTimeAndSpeedText(strMsg);				
			} 
			else 
			{						
				String strMsg = GetResourceString(R.string.Time) + ConversionUtils.msecToTime(ReadTagsTime) + GetResourceString(R.string.Speed)
						+ ReadTagsSpeedNum + GetResourceString(R.string.Units);
				UpdateInventoryTimeAndSpeedText(strMsg);	
								
				LastSpeedNum = ReadTagsSpeedNum;						
				TimerRunCount = ReadTagsSpeedNum = 0;
				if(!IsAssignLastSpeed) IsAssignLastSpeed = true;
			}
		}
		else
		{
			IsTimerFirstRun = false;
		}
	}
	
	
	/**
	 * ¶ʱٶ
	 */
	public void UpdateInventoryTimeAndSpeedText(final String strText)
	{
		this.runOnUiThread(new Runnable() {
			@Override
			public void run() {
				
				if(ReadTagsSpeedNum == 0) NewTagFlag = 0;
				inventoryTimeAndSpeedText.setText(strText);

			}
		});
	}	
	

	//----------ǩݴ----------
	
	/**
	 * ±ǩݻ	
	 * @param tagsData
	 */
	public void UpdateTagsData(String[] tagsData)//str_epc,str_rssi,str_temp,str_tid,str_user
	{				
		ReadTagsSpeedNum++;
		
		tag_str_TagsData[tag_str_tmp_write] = tagsData;
		tag_str_tmp_write++;
		if (tag_str_tmp_write >= Max_Tags_TempBuff) tag_str_tmp_write = 0;
		
		SoundHandler(tagsData[0],tagsData[3]);
	}
	
	
	public void SoundHandler(String epc,String tid)
	{
		//"бǩ", "бǩ", "ָEPC","ָTID"				
		switch(DemoConfig.SoundModeSelectIndex)
		{
		case 0:
			
			break;
		case 1:
			NewTagFlag++;	
			break;
		case 2:
			if(epc.equals(DemoConfig.SoundTagsData)) NewTagFlag++;
			break;
		case 3:
			if(tid.equals(DemoConfig.SoundTagsData)) NewTagFlag++;
			break;
		}
	}
	
	
	/**
	 * ǩݴ߳
	 */
	private void PassiveTagsHandleThreadStart() {
		if (passiveTagsHandleThread == null) {
			passiveTagsHandleThread = new PassiveTagsHandleThread();
			passiveTagsHandleThread.start();
		}
	}

	/**
	 * ֹͣǩݴ߳
	 */
	private void PassiveTagsHandleThreadStop() {
		if (passiveTagsHandleThread != null) {
			passiveTagsHandleThread.stop = true;
			passiveTagsHandleThread = null;
		}
	}
	
	
	private PassiveTagsHandleThread passiveTagsHandleThread;
	private class PassiveTagsHandleThread extends Thread {
		public boolean stop;
		private int count = 0;
		private int findIndex = 0;

		public void run() {
			while (!stop) {
				// 
				// ͨ˯߳öʱʱ ???
				try {
					Thread.sleep(25);
					count = 0;
					while (tag_str_tmp_Read != tag_str_tmp_write) 
					{
						findIndex = FindTagsDataHandle(tag_str_TagsData[tag_str_tmp_Read][tag_str_epc_index],
								                       tag_str_TagsData[tag_str_tmp_Read][tag_str_tid_index]);						
												
						if (findIndex == -4)// 
						{
							showMessage(tag_str_TagsData[tag_str_tmp_Read],findIndex, true);

						} else// ¸ ??
						{
							showMessage(tag_str_TagsData[tag_str_tmp_Read],findIndex, false);
						}

						tag_str_tmp_Read++;
						if (tag_str_tmp_Read >= Max_Tags_TempBuff) tag_str_tmp_Read = 0;
						count++;
						if (count > 50) break;// 15: ÿ ???500 ???- ԭ ???50:ÿ2000 ???
					}
				} catch (Exception ex) {
					Log.i("ERROR",ex + "");
				}
			}
		};
	};


	public int FindTagsDataHandle(String epc, String tid) 
	{
		synchronized (this) 
		{
			int FindListIndex = -4;

			for (int i = 0; i < SourcereceptionArrayList.size(); i++) {
				if (epc.equals(SourcereceptionArrayList.get(i).get(lvAdptrlabEPC))
						&& tid.equals(SourcereceptionArrayList.get(i).get(lvAdptrlabTid))) {// EPCҳEPCͬ,TIDҳTIDͬ
					FindListIndex = i + 1;
					return FindListIndex;
				}
			}

			HashMap<String, String> hashMap = new HashMap<String, String>();
			hashMap.put(lvAdptrlabEPC, epc);
			hashMap.put(lvAdptrlabTid, tid);
			SourcereceptionArrayList.add(hashMap);

			return FindListIndex;
		}
	}
	
	
	private void showMessage(final String[] tagsData, final int FindIndex,final Boolean IsAdd) {
		this.runOnUiThread(new Runnable() {
			@Override
			public void run() {
				
				try 
				{
					if (IsAdd) 
					{
						AddNewDataToListView(tagsData);
					} 
					else 
					{
						String count = "";
						if (DemoConfig.IsReadTemp) count = receptionArrayList.get(FindIndex).get(lvAdptrlabCount);
						else count = receptionArrayList.get(FindIndex).get(lvAdptrlabTemp);
						count = String.valueOf(Integer.valueOf(count) + 1);

						Map = receptionArrayList.get(FindIndex);
						Map.put(lvAdptrlabRssi, tagsData[1]);
						if (DemoConfig.IsReadTemp && !tagsData[2].equals("")) Map.put(lvAdptrlabTemp, tagsData[2]);
						if (DemoConfig.IsReadTemp) Map.put(lvAdptrlabCount, count);
						else Map.put(lvAdptrlabTemp, count);
						// ֻı
						passiveAdapter.update_Hidden(FindIndex, TagsDataLV);
					}

				} 
				catch (Exception ex) {
					Log.i("ERROR", "" + ex);
				}
								
			}
		});
	}
    

    public void AddNewDataToListView(String[] tagsData) 
    {     	  	
		String ListTagsNum = String.valueOf(receptionArrayList.size());
				
    	String count = "";
     	if(receptionArrayList.size()  == 0) count = lvAdptrlabCount;	    		
    	else count = "1";
 	
     	passiveAdapter.addItem(tagsData[0],tagsData[1],tagsData[2],count,tagsData[3],tagsData[4]);//epcrssitempcounttiduser    		
     	passiveAdapter.notifyDataSetChanged();		
		
		long diff = 0;
		if (curDate != null) {
			Date nowDate = new Date(System.currentTimeMillis());
			diff = nowDate.getTime() - curDate.getTime();
		}
													
		if(!ListTagsNum.equals("0")) tagsNumText.setText(GetResourceString(R.string.TagsNum) + ListTagsNum + "    " + String.valueOf(diff) + "MS");				
    }
	
    ///////////////////// Ͻǲ˵ ///////////////////////////////
	
	
	// Ҫѡť״̬setOnSwitchCheckedChangeListenerʵ
	/** ˵¼ӿڶ */
	private DropMenu.OnMenuItemClickListener menuItemClickListener = new DropMenu.OnMenuItemClickListener() {
		@Override
		public void onMenuItemClick(demoui.menu.MenuItem item, View view) 
		{
//			Toast.makeText(MainActivity.this, item.getItemKey() + "," + item.getItemTitle(), Toast.LENGTH_SHORT).show();
			switch(item.getItemKey())
			{
			case "AccessTag"://ǩд
				ShowAccessTagView();
				break;
			case "PowerConfig"://
				PowerUtils.ShowPowerConfigDialog(context);		
				break;
			case "MultiConfig"://Ⱥ
				ShowInventoryConfigView();
				break;
			case "RfidConfig"://Ƶ
				ShowRfidConfigView();
				break;
			case "TagsSound"://귢
				SoundModeSelectUtils.ShowSoundModeSelectDialog(context,valueHandleUtils);
				break;
			case "SaveTxt"://Txt
				SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd- HH:mm:ss");        
			    Date date = new Date(System.currentTimeMillis());        
			    String times = simpleDateFormat.format(date); 
			    times = times.replace(":", "-");
				SaveFileTools.SaveTagsDataToTxt(context,"uhf(" + times + ")",receptionArrayList);		
				break;
			
			}
		}
	};
	
	
	/**
	 * صǩд
	 */
	public void ShowAccessTagView()
	{
		Intent intent;
		intent = new Intent(MainActivity.this, AccessTagActivity.class);
		startActivityForResult(intent, 99);
	}
	
	/**
	 * Ⱥý
	 */
	public void ShowInventoryConfigView()
	{
		Last_IsReadUser = DemoConfig.IsReadUser;
		Last_IsReadTemp = DemoConfig.IsReadTemp;
		
		Intent intent;
		intent = new Intent(MainActivity.this, InventoryConfigActivity.class);
		startActivityForResult(intent,1);	
	}
	
	
	/**
	 * Ƶ
	 */
	public void ShowRfidConfigView()
	{
		Intent intent;
		intent = new Intent(MainActivity.this, SettingsActivity.class);
		startActivityForResult(intent, 98);
	}
	
	
    ////////////////////   淵ش   ////////////////////	
	
	
	public void onActivityResult (int requestCode, int resultCode, Intent data)
	{
		switch (requestCode) {
		case 1:// Ⱥý 
			SetTagsListShow();
			break;
		}		
	}
	
	
  public Boolean Last_IsReadUser = false;//ȺýǰǷȡû
  public Boolean Last_IsReadTemp = false;//ȺýǰǷȡ¶ȱǩ
	
  /**
   * ıǩбʾ
   */
	public void SetTagsListShow() 
	{
		passiveAdapter = new PassiveAdapter(this, receptionArrayList, R.layout.list_passive_tags,
				new String[] { lvAdptrlabEPC, lvAdptrlabRssi, lvAdptrlabTemp, lvAdptrlabCount, lvAdptrlabTid,
						lvAdptrlabUserData },
				new int[] { R.id.Text_Epc,R.id.Text_Rssi,
					    R.id.Text_Temperature,R.id.Text_Count,
					    R.id.Text_Tid,R.id.Text_User});
		TagsDataLV.setAdapter(passiveAdapter);
		passiveAdapter.notifyDataSetChanged();

		if ((Last_IsReadUser != DemoConfig.IsReadUser) || (Last_IsReadTemp != DemoConfig.IsReadTemp)) 
		{
			showDataClear();
			return;
		}
	}
		
    ////////////////////   ؼ¼   ////////////////////
	
	/**
	 * ǩбlistview¼
	 * @param position
	 */
	public void Lv_TagsData_Clicked(int position)
	{
		if(!inventoryBtn.isEnabled())
		{
			ShowToastUtils.ShowToast(context, GetResourceString(R.string.ReadTagsTimeClick));
		}
		else
		{
			// position ѡĸ
			// ˫,1жΪ˫
			if ((position == lastClickId) && (Math.abs(lastClickTime - System.currentTimeMillis()) < 1000)) {
				lastClickId = 0;
				lastClickTime = 0;

				ClickEPC = receptionArrayList.get(position).get(lvAdptrlabEPC);
			
				if(DemoConfig.IsReadTemp)
				{
					if(receptionArrayList.get(position).get(lvAdptrlabTid) != null) 
					{								
						ClickTID = receptionArrayList.get(position).get(lvAdptrlabTid);								
					}
					else 
					{
						ClickTID = "";
					}
				}
				else
				{
					if(receptionArrayList.get(position).get(lvAdptrlabCount) != null) 
					{								
						ClickTID = receptionArrayList.get(position).get(lvAdptrlabCount);								
					}
					else 
					{
						ClickTID = "";
					}
				}
				
				if (!ClickEPC.equals("EPC")) 
				{
					ShowAccessTagView();
				} 
				else 
				{
					ClickEPC = ClickTID = "";
					SortListView();							
				}
			} 
			else // 
			{
				lastClickId = position;
				lastClickTime = System.currentTimeMillis();

				ClickEPC = receptionArrayList.get(position).get(lvAdptrlabEPC);
				
				if(DemoConfig.IsReadTemp)
				{
					if(receptionArrayList.get(position).get(lvAdptrlabTid) != null) 
					{								
						ClickTID = receptionArrayList.get(position).get(lvAdptrlabTid);								
					}
					else 
					{
						ClickTID = "";
					}
				}
				else
				{
					if(receptionArrayList.get(position).get(lvAdptrlabCount) != null) 
					{								
						ClickTID = receptionArrayList.get(position).get(lvAdptrlabCount);								
					}
					else
					{
						ClickTID = "";
					}
				}
				
				if (ClickEPC.equals("EPC")) 
				{
					ClickEPC = ClickTID = "";
					SortListView();		
				}
			}
		}	
	}
	
	//--------------ListView-------------------------------
	
    public int SortUp = 0;
	public int SortDown = 1;
	public int SortType = SortUp;

	class TagsData {
		String TagsEPC;		
		String TagsRssi;
		String TagsTemp;
		String TagsCount;
		String TagsTid;
		String TagsUserData;
	}

	TagsData tagsdata[];

	/**
	 * ListView
	 */
	public void SortListView() 
	{
		tagsdata = new TagsData[receptionArrayList.size() - 1]; //  ??? ???

		for (int i = 1; i < receptionArrayList.size(); i++) {// һ ??? ID Rssi  Count ȡ
			tagsdata[i - 1] = new TagsData(); // ڴȲ ???
			tagsdata[i - 1].TagsEPC = receptionArrayList.get(i).get(lvAdptrlabEPC);
			tagsdata[i - 1].TagsRssi = receptionArrayList.get(i).get(lvAdptrlabRssi);
			tagsdata[i - 1].TagsTemp = receptionArrayList.get(i).get(lvAdptrlabTemp);
			tagsdata[i - 1].TagsCount = receptionArrayList.get(i).get(lvAdptrlabCount);								
			tagsdata[i - 1].TagsTid = receptionArrayList.get(i).get(lvAdptrlabTid);
			tagsdata[i - 1].TagsUserData = receptionArrayList.get(i).get(lvAdptrlabUserData);
		}

		// С
		Arrays.sort(tagsdata, new Comparator<TagsData>() { // ڲ ???
					@Override
					public int compare(TagsData lhs, TagsData rhs) {
						return lhs.TagsEPC.compareTo(rhs.TagsEPC);
					}
				});

		// listview
		this.runOnUiThread(new Runnable() {
			@Override
			public void run() {
				receptionArrayList.clear();
				SourcereceptionArrayList.clear();
				showMessage(StrLvTitleText,0, true);
				passiveAdapter.notifyDataSetChanged();
			}
		});

		SortThreadStart();
	}

	public void SortThreadStart() {
		Sortthread = new SortThread();
		Sortthread.start();
	}

	private SortThread Sortthread;

	private class SortThread extends Thread {
		public void run() {
			SortUpdateListView();
		};
	};

	public void SortUpdateListView() {
		this.runOnUiThread(new Runnable() {
			@Override
			public void run() {

				if (SortType == SortUp) 
				{
					for (int i = 0; i < tagsdata.length; i++) {
						HashMap<String, String> hashMap = new HashMap<String, String>();
						hashMap.put(lvAdptrlabEPC, tagsdata[i].TagsEPC);
						hashMap.put(lvAdptrlabRssi, tagsdata[i].TagsRssi);
						hashMap.put(lvAdptrlabTemp, tagsdata[i].TagsTemp);
						hashMap.put(lvAdptrlabCount, tagsdata[i].TagsCount);
											
						hashMap.put(lvAdptrlabTid, tagsdata[i].TagsTid);
						hashMap.put(lvAdptrlabUserData, tagsdata[i].TagsUserData);
						
						receptionArrayList.add(hashMap);
						SourcereceptionArrayList.add(hashMap);
					}
					SortType = SortDown;
				} 
				else 
				{
					for (int i = tagsdata.length - 1; i >= 0; i--) {
						HashMap<String, String> hashMap = new HashMap<String, String>();
						hashMap.put(lvAdptrlabEPC, tagsdata[i].TagsEPC);
						hashMap.put(lvAdptrlabRssi, tagsdata[i].TagsRssi);
						hashMap.put(lvAdptrlabTemp, tagsdata[i].TagsTemp);
						hashMap.put(lvAdptrlabCount, tagsdata[i].TagsCount);
						
						hashMap.put(lvAdptrlabTid, tagsdata[i].TagsTid);
						hashMap.put(lvAdptrlabUserData, tagsdata[i].TagsUserData);
						
						receptionArrayList.add(hashMap);
						SourcereceptionArrayList.add(hashMap);
					}
					SortType = SortUp;
				}

				String ListTagsNum = String.valueOf(receptionArrayList.size() - 1);
				if(!ListTagsNum.equals("0")) tagsNumText.setText(GetResourceString(R.string.TagsNum) + ListTagsNum);
				passiveAdapter.notifyDataSetChanged();
			}
		});
	}
	
	
    ////////////////////   ҳ渨غ   ////////////////////
	
	
	/**
	 * 
	 */
	public boolean onKeyDown(int keyCode, KeyEvent event) 
	{		
//      ShowToast("ֵ:" + keyCode);
				
		if (keyCode == KeyEvent.KEYCODE_BACK && event.getRepeatCount() == 0) 
		{
			exit();
			return true;
		}

		return super.onKeyDown(keyCode, event);
	}
	
    //---------------˳ʾ-----------------

	/**
	 * ˳ϵͳʾ    
	 */
	private void exit() 
	{
		AlertDialog.Builder builder = new AlertDialog.Builder(MainActivity.this);
		builder.setTitle( GetResourceString(R.string.Prompt)).setMessage(GetResourceString(R.string.IsExitDemo)).setCancelable(true)
				.setIcon(R.drawable.ic_launcher)
				.setPositiveButton(GetResourceString(R.string.Confirm), new DialogInterface.OnClickListener() {
					public void onClick(DialogInterface dialog, int id) {
						ExitDemo();						
					}
				}).setNegativeButton(GetResourceString(R.string.Cancel), new DialogInterface.OnClickListener() {
					public void onClick(DialogInterface dialog, int id) {
						dialog.cancel();
					}
				});
		AlertDialog alert = builder.create();
		alert.show();
	}

	
	public void ExitDemo() 
	{
		try 
		{
			sdkCallBackMethod.StopMultiTags(context);
			if(bleHandle.bleConnectState) bleHandle.DisConnectBleDevice(bleHandle.actionBleDevice);//Ͽ

			SoundModeSelectUtils.soundPool.release();
			SoundThreadStop();
			PassiveTagsHandleThreadStop();
			
			System.exit(0);//Ϊҳʼ
		} 
		catch (Exception e) 
		{
			// TODO Auto-generated catch block
		}
	}
	
	
	/**
	 * ȡԴļַ
	 * @param stringID
	 * @return
	 */
	public static String GetResourceString(int stringID)
	{
		return context.getResources().getString(stringID);		
	}
	
}
