package demoui.ble;

import com.example.passivebledemo.R;

import android.app.AlertDialog;
import android.app.Dialog;
import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.TextView;

public class LoadingDialog {

    private Dialog dialog;
    private TextView connectingText;
    public boolean showState = false;

    public LoadingDialog(Context context) {
        LayoutInflater inflater = (LayoutInflater) context.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
        View view = inflater.inflate(R.layout.dialog_loading, null);
        connectingText = (TextView) view.findViewById(R.id.ConnectingText);
        AlertDialog.Builder builder = new AlertDialog.Builder(view.getContext(),R.style.AlertDialogStyle);
        builder.setView(view);
        dialog = builder.create();
        dialog.setCancelable(false);
    }


    public void show() {
        if (dialog != null && !dialog.isShowing()) {
            showState = true;
            dialog.show();
        }
    }

    public void dismiss() {
        try {
            if (dialog != null && dialog.isShowing()) {
                showState = false;
                dialog.dismiss();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void setCancelable(boolean flag) {
        if (dialog != null) {
            dialog.setCancelable(flag);
        }
    }
    
    public void setConnectingText(String text)
    {
    	if(connectingText != null) connectingText.setText(text);
    }
	
}

