package uhfutils;

import java.io.UnsupportedEncodingException;
import java.util.Date;

import com.example.passivebledemo.MainActivity;
import com.example.z_android_sdk.Reader;

import BlueTooth.BlueToothTypes;
import android.content.Context;
import android.os.Message;
import android.util.Log;
import tools.ConversionUtils;
import tools.DemoConfig;
import uhf.api.ActiveTag;
import uhf.api.CommandType;
import uhf.api.MultiLableCallBack;
import uhf.api.ShareData;

public class SdkCallBackMethod implements MultiLableCallBack  {
	
	MainActivity mainActivity;
	public static Reader ReaderController;
	
	public SdkCallBackMethod(Context context)
	{
		this.mainActivity = (MainActivity)context;
		
		ReaderController = new Reader("BlueTooth",mainActivity);
		ReaderController.SetCallBack(this);// עصʹ		
		ReaderController.SetHeartThread(true);// ʱ·
	}
	
	
	/**
	 * ֹͣ
	 */
	public void StopMultiTags(Context context)
	{
		try
		{
			ReaderController.UHF_CMD(CommandType.Read_TagTemp_Stop, null);
			Thread.sleep(100);
			Boolean ret = ReaderController.UHF_CMD(CommandType.STOP_MULTI_QUERY_TAGS_EPC, null);
			if (!ret) ReaderController.UHF_CMD(CommandType.STOP_MULTI_QUERY_TAGS_EPC, null);
		}
		catch(Exception ex)
		{
			
		}
	}


	@Override
	public void method(byte[] data) {
		// TODO Auto-generated method stub
		if (data.length <= 0) {
			return;
		}       	

		// 3000 E28011052000590BC06D0897 E28011052000590BC06D0897 0000 01

		byte msb = data[0];
		byte lsb = data[1];
		int pc = (msb & 0x00ff) << 8 | (lsb & 0x00ff);
		pc = (pc & 0xf800) >> 11;

		byte[] epc = new byte[pc * 2];
		System.arraycopy(data, 2, epc, 0, epc.length);
		String str_epc = "";	
		
		str_epc = ShareData.CharToString(epc, epc.length);
		str_epc = str_epc.replace(" ", "");		
		
		byte[] tid = new byte[data.length - 2 - (pc * 2) - 3];
		System.arraycopy(data, 2 + (pc * 2), tid, 0, tid.length);
		String str_tid = ShareData.CharToString(tid, tid.length);
		str_tid = str_tid.replace(" ", "");

		String str_rssi = "" + (~((short) (((data[2 + pc * 2 + tid.length] & 0xFF) << 8)
				| (data[2 + pc * 2 + 1 + tid.length] & 0xFF) - 1)) / -10.0);

		String str_temp = "";
		String str_user = "";

		//if(!str_tid.equals("") && DemoConfig.IsReadTid == false) DemoConfig.IsReadTid = true;		
		String[] result = new String[] {str_epc,str_rssi,str_temp,str_tid,str_user};
		mainActivity.UpdateTagsData(result);
	}

	
	@Override
	public void CmdRespond(String[] data) {
		// TODO Auto-generated method stub
		String[] result = null;
		//String[] result = new String[] {str_epc,str_rssi,str_temp,str_tid,str_user};		
		String CmdType = data[1];
		
		switch(CmdType)
		{
		case "F8":
			//String[] result = new String[] { "","F8", str_epc, RSSI, StrTemp,SensorTagType,"" };
			result = new String[] {data[2].replace("-", ""),data[3],data[4],data[6],""};
			break;
		case "F7":
			// String[] result = new String[] { "","F7", epc, RSSI, temperature,SensorTagType,"" };
			result = new String[] {data[2].replace("-", ""),data[3],data[4],"",""};
			break;
		case "79":
			result = new String[] {data[2].replace("-", ""),data[3],"",data[4].replace("-", ""),data[5]};	
			break;
		}
			
		if(result.length != 0) mainActivity.UpdateTagsData(result);
	}
	

	@Override
	public void BlueToothBtnNew(int multiValue) 
	{
		Log.i("UpdateMultiTagsAction", multiValue + "");
		//0:ֹͣ 1:ʼ
		mainActivity.UpdateMultiTagsAction(multiValue);
	}

	
	@Override
	public void BlueToothVoltageNew(int voltage, byte BatteryStatus, byte ModuleWorkStatus, int Voltseg2, int Voltseg1,
			int Voltseg0) 
	{
		//voltage-ѹֵ
		//BatteryState-״̬
		//ģ鹤״̬-ModuleWorkState		
		//Voltseg2Voltseg1Voltseg0-еεѹ
		mainActivity.UpdateBleDeviceMessage(voltage,BatteryStatus,ModuleWorkStatus,
				Voltseg2,Voltseg1,Voltseg0);
	}

	
	@Override
	public void SdkActionResult(String ResultStr) 
	{
		Log.e("BlueTooth", "յSdkActionResultϢResultStr=" + ResultStr);
		String[] result = ResultStr.split("\\,");
		switch (result[0]) 
		{
		case BlueToothTypes.BlueToothMsgType:
			mainActivity.UpdateBleConnectDeviceState(Integer.parseInt(result[1]));
			break;
		}		
	}
	
	
	@Override
	public void RecvActiveTag(ActiveTag arg0) {
		// TODO Auto-generated method stub
		
	}
	
	@Override
	public void BlueToothBtn() {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void BlueToothVoltage(int arg0) {
		// TODO Auto-generated method stub
		
	}




}
